:(mm,#!,())
:(o,,(
<**>
<* GENLEARN.STP - WDial teach Mode Script *>
<**>
))


:(s,teach.)                     :(o,,<* My home          *>)
:(s,teach.Version,(3.20))       :(o,,<* Genlearn version *>)

:(mm,#!,(       :(o,,<* Intercept TRAC responses *>)
))

:(o,,(
<**>
<* Messages to the user *>
<**>
))
:(s,teach.IPMSS,
(One or more IP Addresses have been received from the Service Provider.  These are usually assigned on a per session basis.

The next prompt will ask which IP Address to use for this session (the first one, the second one...).  Dialer will then know to always pick the IP Address in that position in the future.

If you have already configured an IP Address from your Service Provider you may want to choose 'None'.

Please contact your Service Provider if you are unsure which IP Address to choose.))

:(s,teach.IPPRMPT,
(Please select an IP address, or None))

:(s,teach.EXMSS,
(Because this is the first time you are connecting to this service, the Dialer will prompt you for information that the Internet service needs.

If you need help understanding what the Dialer is prompting you for, contact your Internet service provider.))

:(s,teach.ABMSS,
(Teach mode ABORTED. No script will be created.))

:(s,teach.MSGNOMODEM,
(Your modem is not responding. )
(Please be sure it is turned on and connected to your )
(computer correctly. Would you like to try again?))

:(s,teach.MSGMODEMERR,(Modem Error, Connection Failed))
:(s,teach.MSGBUSY,(The number you dialed is Busy. Would you like to try again?))
:(s,teach.MSGNOCARRIER,(Unable to connect to remote modem. Would you like to try again?))
:(s,teach.MSGNODIALTONE,(No Dialtone. Would you like to try again?))
:(s,teach.MSGNOANSWER,(No Answer. Would you like to try again?))
:(s,teach.MSGTIMEOUT,(TIMEOUT. Would you like to try again?))
:(s,teach.MSGNOPHYSICAL,(Physical layer not opened. Connection Failed!))
:(s,teach.MSGNOLCP,(Link control not established. Connection Failed!))
:(s,teach.MSGNOIPCP,(Network control not established. Connection Failed!))
:(s,teach.MSGNOCF,(Fatal Error; cannot create file '<1p>'!))
:(s,teach.MSGNOGENLEARN,(Fatal Error; cannot open GENLEARN.SCR!))
:(s,teach.MSGHANGUP,(The other side hung up. Connection Failed!))
:(s,teach.MSGNOHANGUP,(The provider never hung up. Connection Failed!))
:(s,teach.MSGNOCALLBACK,(The provider never called back. Connection Failed!))
:(s,teach.MSGNOCONNECT,(Unable to connect to remote modem. Connection Failed!))

:(o,,(
<**>
<* Build key value db *>
<**>
))
:(mm,teach.loadkeys,(
	:(d,<0>)
	:(s,teach.keys.)

	<* Control Keys *>
	:(<0>2,(Carriage Return),(<Enter>),(:(bxo,0d)))
	:(<0>2,(Escape),(<ESC>),(:(tca,27)))
	:(<0>2,(NUL),(<NUL>),(:(tca,0)))
	:(<0>2,(BEL),(<BEL>),(:(tca,7)))
	:(<0>2,(BS),(<BS>),(:(tca,8)))
	:(<0>2,(Line Feed),(<LF>),(:(tca,10)))
	:(<0>2,(Form Feed),(<FF>),(:(tca,12)))
	:(<0>2,(DEL),(<DEL>),(:(tca,127)))
	:(<0>2,(Space),(<Space>),(:(tca,32)))
	:(<0>2,(XON),(<XON>),(:(tca,17)))
	:(<0>2,(XOFF),(<XOFF>),(:(tca,19)))
	<* Control Characters *>
	:(pc,(
		:(<0>2,(Ctl-):(tca,:(aa,:(pn),64)),(<Ctl-):(tca,:(aa,:(pn),
			64))(>),(:(tca,:(pn))))
	),26,1)


	:(d,<0>2)
))

:(o,,(
<**>
<* Key value builder part Deuce *>
<**>
))
:(mm,teach.loadkeys2,(
	:(s,teach.keys.num,:(aa,0:(r,teach.keys.num),1))
	:(s,teach.keys.k:(r,teach.keys.num),(<1>))
	:(s,teach.keys.v:(r,teach.keys.num),(<2>))
	:(s,teach.keys.a:(r,teach.keys.num),<3>)
))
:(teach.loadkeys)   :(o,,<* Fill key database and chuck loader *>)

:(o,,(
<**>
<* Convert Mnemonics To ASCII *>
<* Process send-key string     *>
<**>
))
:(mm,teach.convkeys,(
	:(s,<0>temp,:(r,<1p>))

	<* Convert Mnemonics to ASCII *>
	:(pc,(
		<* Replace key with ASCII values *>
		:(tra,<0>temp,:(r,teach.keys.v:(pn)),
			<* Handle multi value keys *>
			:(s,<0>x,:(pn))
			:(tps,teach.keys.a:(r,<0>x),0)
			:(pc,(
				:(tca,40)(char,):(tcn,:(tn,teach.keys.a
					:(r,<0>x),1)):(tca,41)
			),:(tl,teach.keys.a:(r,<0>x)))
			(`)
		)
	),:(r,teach.keys.num),1)

	:(r,<0>temp)						<* Return Result *>
	:(d,<0>temp,<0>x) 			<* Clean up *>
))


:(o,,(
<**>
<* Build db of default prompts and suggested responses *>
<**>
))
:(mm,teach.loadprompts,(
	:(d,<0>)

	:(s,teach.prompts.)
	:(<0>2,(login:),2,y)
	:(<0>2,(username:),2,y)
	:(<0>2,(userid:),2,y)
	:(<0>2,(id:),2,y)
	:(<0>2,(password:),3,y)
	:(<0>2,(who),2)
	:(<0>2,(id),2)
	:(<0>2,(user),2)
	:(<0>2,(login),2)
	:(<0>2,(name),2)
	:(<0>2,(secret),3)
	:(<0>2,(security),3)
	:(<0>2,(key),3)
	:(<0>2,(call back),7)
	:(<0>2,(callback),7)
	:(<0>2,(dialback),7)
	:(<0>2,(dial back),7)

	<* Start of PPP LCP Negotiation? *>
	:(ei,:(wdial_frametype),PPP,(
		:(<0>2,:(bxo,7D207D),0,y,y)
	))

	:(s,teach.prompts.msg0,(I am done with this teaching session))
	:(s,teach.prompts.msg1,(Abort this teaching session))
	:(s,teach.prompts.msg2,(Use my username here))
	:(s,teach.prompts.msg3,(Use my password here))
	:(s,teach.prompts.msg4,(Send a carriage return here))
	:(s,teach.prompts.msg5,(Send specific keys here))
	:(s,teach.prompts.msg6,(Ignore this prompt))
	:(s,teach.prompts.msg7,(Wait for callback))
	:(s,teach.prompts.nummsg,8)

	<* Dump loader part 2 *>
	:(d,<0>2)

))

:(o,,(
<**>
<* Loadprompts Part Deuce-The workhorse *>
<**>
))
:(mm,teach.loadprompts2,(
	:(s,teach.prompts.num,:(aa,0:(r,teach.prompts.num),1))
	:(s,teach.prompts.p:(r,teach.prompts.num),(<1>))
	:(s,teach.prompts.d:(r,teach.prompts.num),(<2>))
	:(ei,<3>,,,(
		:(s,teach.prompts.e:(r,teach.prompts.num))
	))
	:(ei,<4>,,,(
		:(s,teach.prompts.X:(r,teach.prompts.num))
	))
))
:(ri,teach.loadprompts) :(o,,<* Build prompt db & discard loader *>)

:(o,,(
<**>
<* Parse out the important part out a prompt *>
<* From the last CR                          *>
<**>
))
:(mm,teach.getprompt,(
	:(wdial_status,(Waiting for prompt...))
	:(s,<0>data,:(teach.iwts2)) <* Get data from strm *>
	:(s,<0>data,:(r,<0>data):(bxo,0d0a))

	:(tps,<0>data,0)
	:(tra,<0>data,:(bxo,0d),:(bxo,0a))	<* convert CRs to LFs *>
	:(tps,<0>data,0)
	:(s,<0>retval) <* Start with no return value *>

	:(pcd,(
		<* Find next LF delimitted prompt OR exit *>
		:(s,<0>temp2,:(ts,<0>data,,:(bxo,0a),(:(px))))

		:(ei,:(r,<0>temp2),,,(
			<* A prompt, save it if not NULL *>
			:(s,<0>retval,:(r,<0>temp2))
		))
	),-1)

	<* Reverse Prompt *>
	:(d,<0>revp)
	:(tps,<0>retval,0)
	:(pc,(
		:(s,<0>revp,:(tn,<0>retval,1):(r,<0>revp))
	),:(tl,<0>retval))

	<* Reverse again this time cropping more *>
	:(tps,<0>revp,0)
	:(d,<0>retval)
	:(d,<0>pflag)
	:(d,<0>xflag)
	:(pc,(
		:(s,<0>tchar,:(tn,<0>revp,1))
		:(pc,(
			:(mhi,<0>pflag,,(
				:(agi,33,:(tcn,:(r,<0>tchar)),(
					:(px)
				))
			))
			:(s,<0>pflag)
			:(agi,33,:(tcn,:(r,<0>tchar)),(
				:(s,<0>xflag)
				:(px)
			))
			:(s,<0>retval,:(r,<0>tchar):(r,<0>retval))
		),1)
		:(mhi,<0>xflag,(:(px)))
	),:(tl,<0>revp))

	<* Return cropped prompt *>
	:(r,<0>retval)
	:(wdial_status,(Prompt received.))

	<* Clean up *>
	:(d,<0>xflag,<0>revp,<0>pflag,<0>tchar,<0>retval,<0>temp2,<0>data)
))

:(mm,teach.rd,(
	:(s,<0>temp,:(iwt2,1))
	:(ei,:(wdial_frametype),SLIP,(
		:(ei,,:(r,<0>temp),,(
			:(ri,slang.ip.scan,:(r,<0>temp))
		))
	))
	:(r,<0>temp)
	:(d,<0>temp)
))

:(mm,teach.iwt2,(
	:(s,<0>timer,:(xcm))
	:(d,<0>retval)

	:(pc,(
		<* Use iwt2 cuz i2 is broken *>

		<* Added hook for IP Address parsing *>
		:(s,<0>retval,:(r,<0>retval):(teach.rd))

		:(<0>2,<0>retval,(<2p>))
		:(<0>2,<0>retval,(<3p>))
		:(<0>2,<0>retval,(<4p>))
		:(<0>2,<0>retval,(<5p>))
		:(<0>2,<0>retval,(<6p>))
		:(<0>2,<0>retval,(<7p>))
		:(<0>2,<0>retval,(<8p>))
		:(<0>2,<0>retval,(<9p>))
		:(<0>2,<0>retval,(<10p>))
		:(<0>2,<0>retval,(<11p>))
		:(<0>2,<0>retval,(<12p>))
		:(<0>2,<0>retval,(<13p>))
		:(<0>2,<0>retval,(<14p>))
		:(<0>2,<0>retval,(<15p>))
		:(<0>2,<0>retval,(<16p>))

		:(agi,:(as,:(xcm),:(r,<0>timer)),0<1>,(
			:(s,<0>retval)
			:(px)
		))
	),-1)
	:(r,<0>retval)

	<* Clean Up *>
	:(d,<0>retval,<0>timer)
))
:(o,,<* Part Two *>)

:(mm,teach.iwt22,(
	:(ei,<2>,,,(
		:(ttci,<1>,<2>,(
			:(px)
		))
	))
))
`
:(o,,(
<**>
<* Suck in until recognized prompt or 5 second pause in stream *>
<**>
))
:(mm,teach.iwts2,(
	:(s,<0>timer,:(xcm))		<* Reset timer *>
	:(s,<0>itimer,:(xcm)) 	<* Total Timer *>
	:(d,teach.sugres) 			<* Reset suggested response *>
	:(d,<0>retval)					<* Clear return value *>
	:(d,<0>pfound)					<* Prompt found flag *>
	:(d,<0>probprompt)			<* Clear probable prompt flag *>
	:(d,teach.defprompt)		<* Definite Prompt *>

	<* Loop until we find a prompt *>
	:(pcd,(
		:(mhi,teach.defprompt,(:(px)))	<* Exit immediatelly *>

		:(s,<0>tmp,:(teach.rd)) 	<* Get data from stream *>

		:(agi,:(as,:(xcm),:(r,<0>itimer)),20000,(
			<* Maximum Prompt Timer Exceeded, *>
			<* Prevent Endless Loop.					*>

			:(s,teach.sugres,0) 		<* Done *>
			:(px)
		))

		:(ei,:(r,<0>tmp),,(
			<* Check For 5 Second Pause (Approx.) 			*>
			<* 2 Seconds If Probable Prompt Flag Set		*>
			:(agi,:(as,:(xcm),:(r,<0>timer)),:(mh,<0>probprompt,
				2000,5000),(
				:(px)
			))
		),(
			<* Concatanate Return Value, and Update Timer *>
			:(s,<0>retval,:(r,<0>retval):(r,<0>tmp))
			:(s,<0>timer,:(xcm))
			:(d,<0>probprompt)			<* Clear Prob. Prompt Flag *>

			<* Remove excess spewage from <0>retval *>
			:(s,<0>rtemp,:(r,<0>retval))
			:(tra,<0>rtemp,:(tca,10),:(tca,13))
			:(d,<0>cr)
			:(agi,:(tl,<0>rtemp),0,(
				:(tps,<0>rtemp,:(as,:(tl,<0>rtemp),1))
				:(ei,:(tn,<0>rtemp,1),:(tca,13),(
					:(s,<0>cr)
				))
			))
			:(mhi,<0>cr,,(:(s,<0>rtemp,:(r,<0>rtemp):(tca,13))))
			:(tps,<0>rtemp,0)
			:(d,<0>lps)
			:(pc,(
				:(s,<0>lp,:(ts,<0>rtemp,,:(tca,13),(:(px))))
				:(ei,:(r,<0>lp),,,(
					:(s,<0>lps,:(r,<0>lp))
				))
			),-1)
			:(s,<0>retval,:(r,<0>lps):(mh,<0>cr,:(tca,13)))
			:(d,<0>rtemp,<0>lps,<0>cr,<0>lp)

			<* Look for certain prompt *>
			:(pc,(
				<* Search for matching prompt *>
				<* Only if I am certain is prompt ext *>
				:(mhi,teach.prompts.e:(pn),(
					:(ttci,<0>retval,:(r,teach.
						prompts.p:(pn)),(

						<* Set sug response *>
						:(s,teach.sugres,:(r,
							teach.prompts.d
							:(pn)))

						:(mhi,teach.prompts.X:(pn),(
							:(s,teach.defprompt,
								:(r,teach.
								prompts.d
								:(pn)))
							:(px)
						))

						<* I think I have found a *>
						<* Prompt, set flag *>
						:(s,<0>probprompt)
						:(px)
					))
				))
			),:(r,teach.prompts.num),1) <* Looking *>

			:(mhi,teach.sugres,(:(px))) <* Exit loop *>
		))
	),-1) <* Prompt found *>

	<* Search for suggested response *>
	:(mhi,teach.sugres,,(
		<* Look only if no certain prompt *>
		:(pc,(
			:(ttci,<0>retval,:(r,teach.prompts.p:(pn)),(
				<* Found suggestion *>
				:(s,teach.sugres,:(r,teach.prompts.d
					:(pn)))
				:(px)
			))
		),0:(r,teach.prompts.num),1)
	))

	<* Return prompt *>
	:(r,<0>retval)

	<* Clean up *>
	:(d,<0>timer,<0>tmp,<0>retval,<0>itimer)
))

:(o,,(
<**>
<* Initialize The Modem *>
<**>
))

:(mm,teach.modeminit,(
	:(wdial_status,(Initializing the modem...))

	:(s,<0>tmp,:(wdial_modem,init))
	:(pc,(
		:(pc,(
			:(ei,:(tn,<0>tmp,1,(:(px))),~,(
				:(iwm,1000)
			),(
				:(tps,<0>tmp,:(as,:(tpr,<0>tmp),1))
				:(px)
			))
		),-1)
		:(iz2)
		:(s,<0>init,:(ts,<0>tmp,,|,(:(px))):(bxo,0d))<* init string	*>
		:(o2,:(r,<0>init))
		:(s,<0>resp,:(iwt2,10000,OK,ERROR))
		:(pc,(
			:(ttci,<0>resp,OK,(
				:(px)
			))
			:(ttci,<0>resp,ERROR,(
				:(wdial_status,(Modem Error))
				:(g)
			))
			:(wdial_messagei,:(r,teach.MSGNOMODEM),YESNO,Q,1,(
				:(tps,<0>tmp,0)
				:(ibdf)
				:(iwm,1000)
				:(ibdo)
				:(iwm,1000)
			),(
				:(wdial_status,(No response from modem))
				:(g)
			))
		))
	),-1)

	<* Clean up *>
	:(iwm,2000)
	:(d,<0>resp)
	:(d,<0>tmp)

	:(wdial_status,(Initializing the modem...)(Done))
))

:(o,,(
<**>
<* Dial The Service *>
<**>
))

:(mm,teach.connect,(
	:(teach.modeminit)											<* Init the modem *>
	:(s,<0>pnum,:(wdial_phone,number))
	:(ei,:(r,<0>pnum),,(
		:(s,<0>pnum,:(wdial_prompt,(Please enter the phone number to dial:)))
	))
	:(tra,<0>pnum,:(tca,40))								<* Rip out stupid parens *>
	:(tra,<0>pnum,:(tca,41))
	:(tra,<0>pnum,(-))											<* Rip out dashes *>


	:(s,<0>dmsg,(NONE))
	:(pc,(
		:(wdial_status,(Last Error:):(r,<0>dmsg):(bxo,0a)(Dialing...))
		:(d,<0>again) 									<* Clear again flag *>
		:(iz2)

		<* Dial *>
		:(o2,
			:(wdial_modem,dial) 						<* Modem Dial String *>
			:(ei,,:(wdial_phone,prefix),,(	<* Dial Prefix? *>
				:(wdial_phone,prefix)
				:(pc,(:(wdial_modem,pause)),2)
			))
			:(r,<0>pnum)										<* Phone Number *>
			:(ei,,:(wdial_phone,ext),,( 		<* Phone Extension? *>
				:(pc,(:(wdial_modem,pause)),2)
				:(wdial_phone,ext)
			))
			:(bxo,0d) 											<* Carriage Return *>
		)

		<* Wait for response *>
		:(wdial_status,
			(Last Error:):(r,<0>dmsg):(bxo,0a)(Dialing...):(bxo,0a)(Timeout in %d seconds),
			:(aq,:(wdial_phone,timeout),1000))
		:(s,<0>resp,:(teach.iwt2,:(wdial_phone,timeout),(CONNECT),
			(BUSY),(ERROR),((NO CARRIER)),((NO DIALTONE)),((NO ANSWER))))
		:(pc,(
			:(ttci,<0>resp,CONNECT,(
				:(px)
			))
			:(ttci,<0>resp,ERROR,(
				:(wdial_status,(Modem Error))
				:(wdial_message,:(r,teach.MSGMODEMERR),OK,e)
				:(px)
			))
			:(ttci,<0>resp,BUSY,(
				:(wdial_status,(BUSY))
				:(s,<0>tmp,:(wdial_message,:(r,teach.MSGBUSY),YESNO,q,1,y,n))
				:(ei,:(r,<0>tmp),y,(
					<* Reset status message, and loop again *>
					:(s,<0>dmsg,(BUSY))
					:(s,<0>again)
				))
				:(px)
			))
			:(ttci,<0>resp,(NO CARRIER),(
				:(wdial_status,(NO CARRIER))
				:(s,<0>tmp,:(wdial_message,:(r,teach.MSGNOCARRIER),YESNO,q,1,y,n))
				:(ei,:(r,<0>tmp),y,(
					<* Reset status message, and loop again *>
					:(s,<0>dmsg,(NO CARRIER))
					:(s,<0>again)
				))
				:(px)
			))
			:(ttci,<0>resp,(NO DIALTONE),(
				:(wdial_status,(NO DIALTONE))
				:(s,<0>tmp,:(wdial_message,:(r,teach.MSGNODIALTONE),YESNO,q,1,y,n))
				:(ei,:(r,<0>tmp),y,(
					<* Reset status message, and loop again *>
					:(s,<0>dmsg,(NO DIALTONE))
					:(s,<0>again)
				))
				:(px)
			))
			:(ttci,<0>resp,(NO ANSWER),(
				:(wdial_status,(NO ANSWER))
				:(s,<0>tmp,:(wdial_message,:(r,teach.MSGNOANSWER),YESNO,q,1,y,n))
				:(ei,:(r,<0>tmp),y,(
					<* Reset status message, and loop again *>
					:(s,<0>dmsg,(NO ANSWER))
					:(s,<0>again)
				))
				:(px)
			))
			:(o2,:(bxo,0d))
			:(wdial_status,(TIMEOUT))
			<* Unknown Result / TIMEOUT *>
			:(s,<0>tmp,:(wdial_message,:(r,teach.MSGTIMEOUT),YESNO,q,1,y,n))
			:(iwm,5000)
			:(iz2)
			:(ei,:(r,<0>tmp),y,(
					<* Reset status message, and loop again *>
					:(s,<0>dmsg,(TIMEOUT))
					:(s,<0>again)
			))
		))

		:(mhi,<0>again,,(
			<* Don't loop again *>
			:(px)
		))
	),-1)

	<* Clean Up *>
	:(d,<0>resp,<0>pnum,<0>dmsg)

	:(wdial_polli,physical,open,1000,(
		:(wdial_status,(Physical connection established))
	),(
		:(wdial_message,:(r,teach.MSGNOPHYSICAL),OK,E)
		:(teach.exit)
	))
))
`
:(o,,(
<**>
<* The heart and sole of genlearn *>
<**>
))

:(mm,teach.genlearn,(
	:(s,teach.script) 			<* Start with a blank script *>
	:(teach.start_scr)			<* General script filler *>

	<* First time message *>
	:(ei,:(wdial_frametype),PPP_NOPROMPT,,(
		:(wdial_message,:(r,teach.EXMSS),OK,I)
	))

	:(teach.connect)				<* Connect to service/DIAL *>

	<**>
	<* If no login sequence, no need to learn anything *>
	<**>
	:(ei,:(wdial_frametype),PPP_NOPROMPT,(
		<* Go to packet mode *>
		:(wdial_status,(Changing to packet mode))
		:(wdial_changemode,packet)

		:(teach.write_scr)

		<* Write a vanilla script file *>
		:(teach.genlearn0,<1p>)

		<* Wait for LCP and IPCP *>
		:(teach.wait_PPP)

		:(wdial_status,(Connected))
		:(g) <* End the script *>
	))

	<* Loop until user says to stop/abort or until end prompt recvd *>
	:(pcd,(
		<* Get a prompt *>
		:(s,<0>temp,:(teach.getprompt))

		:(mhi,teach.defprompt,(
			<* Don't prompt user, I am sure how to respond *>
			:(s,<0>rnum,:(r,teach.defprompt))
			:(wdial_status,(Automatically replying to prompt))

			:(d,teach.defprompt)
		),(
			<* Build a wdial_prompt command, yech! *>
			:(s,<0>prompt,(:):(tca,40)(wdial_prompt,):(tca,40)
				(How do you respond to "):(tca,41)
				(:(r,<0>temp)):(tca,40)("?):(tca,41)(,,)
				:(mh,teach.sugres,(:(r,teach.prompts.msg
					:(r,teach.sugres))))
				:(pc,(
					(,):(tca,40)
					:(r,teach.prompts.msg:(pn)):(tca,41)
				),:(r,teach.prompts.nummsg),0)
				:(tca,41))

			<* Ask the user what to do with the prompt *>
			<* Copy Suggested Prompt *>


			:(wdial_status,(Waiting for user input))
			<* Prompt User *>
			:(s,<0>temp2,:(ri,<0>prompt))

			<* Reset response number *>
			:(s,<0>rnum,-1)

			<* See if this is a canned response *>
			:(pcd,(
				:(ei,:(r,<0>temp2),:(r,teach.prompts.
					msg:(pn)),(
					:(s,<0>rnum,:(pn))
					:(px)
				))
			),:(r,teach.prompts.nummsg),0) <* Canned? *>
		))

		<* Check if a ctl respe (done,abort,ignore)*>
		:(s,<0>noprompt,:(e,:(r,<0>rnum),0,y):(e,:(r,<0>rnum),1,y)
			:(e,:(r,<0>rnum),6,y):(e,:(r,<0>rnum),7,y)
			:(ei,:(r,<0>temp),,(:(teach.write_scr,(:(tca,40)(pause,2000):(tca,41))))y)
		)

		<* Wait for prompt *>
		:(ei,:(r,<0>noprompt),,(
			<* Bld scrpt, chck agst prmpt *>
			:(teach.write_scr,((<)(* Waiting For Prompt ")
				:(r,<0>temp)(" *)(>)))
			:(teach.write_scr,(:(tca,40)(define,input_data,)
				:(tca,40)(receive,5000,{):(r,<0>temp)(})
				:(tca,41):(tca,41)))
			:(teach.write_scr,(:(tca,40)(did_they_hang_up?):(tca,41)))
			:(teach.write_scr,(:(tca,40)(has,input_data,{)
				:(r,<0>temp)(},{)))
			:(teach.write_scr,(:(tca,9)(<)
				(* Found prompt *)(>)))
			:(teach.write_scr_nocrlf,(:(tca,9)))
		))

		:(ei,:(r,<0>rnum),-1,(
			<* Not canned, original work! *>

			:(s,<0>temp3,:(r,<0>temp2))

			<* Protect parens and gt-lt symbols *>
			:(tra,<0>temp2,:(tca,40),(}):(tca,40)(char,40)
				:(tca,41)({))
			:(tra,<0>temp2,:(tca,41),(}):(tca,40)(char,41)
				:(tca,41)({))
			:(tra,<0>temp2,(<),(}):(tca,41)(char,60):(tca,41)({))
			:(tra,<0>temp2,(>),(}):(tca,41)(char,62):(tca,41)({))
			:(s,<0>temp2,({):(r,<0>temp2)(}))

			<* Write to script *>
			:(teach.write_scr,(:(tca,40)(send,):(r,<0>temp2)
				:(tca,40)(cr):(tca,41):(tca,41)))

			<* Send to stream *>
			:(o2,:(r,<0>temp3):(bxo,0d))
			:(d,<0>temp3)

		),(
			<* Boring canned response *>
			:(ri,<0>:(r,<0>rnum),<1p>,:(e,:(r,<0>noprompt),,(:(tca,9))))
		))

		<* Else case for prompt *>
		:(ei,:(r,<0>noprompt),,(
			:(teach.write_scr,(:(tca,9)))
			:(teach.write_scr,((},{)))
			:(teach.write_scr,(:(tca,9)(<)
				(* Unknown prompt, get help from user *)(>)))
			:(teach.write_scr,(:(tca,9)))
			:(teach.write_scr,(:(tca,9):(tca,40)(response_not_recognized):(tca,41)))
			:(teach.write_scr,((}):(tca,41)))
			:(teach.write_scr)
		))
	),-1) <* Loop til user says uncle *>

	<* Clean up *>
	:(d,<0>temp,<0>temp2,<0>rnum,teach.sug)

	<* To packet mode *>
	:(wdial_status,(Changing to packet mode))
	:(wdial_changemode,packet)

	:(ei,:(wdial_frametype),PPP,(
		:(teach.wait_PPP)
	))

	:(wdial_status,(Connected))
	:(g) <* End the script *>
))

:(o,,(
<**>
<* Wait for PPP LCP and IPCP layers to open *>
<**>
))

:(mm,teach.wait_PPP,(
	:(wdial_status,(Waiting for Link Control...):(bxo,0a)
		(Timeout in %d seconds),:(aq,
		:(wdial_phone,timeout),1000))
	:(s,<0>time,:(aa,:(xcm),:(wdial_phone,timeout)))
	:(pc,(
		:(teach.checkcarrier)
		:(wdial_polli,lcp,open,1000,(
			:(px)
		))
		:(agi,:(xcm),:(r,<0>time),(
			:(wdial_changemode,raw)
			:(teach.hangup)
			:(wdial_status,(Not connected))
			:(wdial_message,:(r,teach.MSGNOLCP),OK,e)
			:(teach.exit)
		))
	),-1)

	:(wdial_status,(Waiting for Network Control...):(bxo,0a)
		(Timeout in %d seconds),:(aq,
		:(wdial_phone,timeout),1000))
	:(s,<0>time,:(aa,:(xcm),:(wdial_phone,timeout)))
	:(pc,(
		:(teach.checkcarrier)
		:(wdial_polli,ipcp,open,1000,(
			:(px)
		))
		:(agi,:(xcm),:(r,<0>time),(
			:(wdial_changemode,raw)
			:(teach.hangup)
			:(wdial_status,(Not connected))
			:(wdial_message,:(r,teach.MSGNOIPCP),OK,e)
			:(teach.exit)
		))
		
	),-1)
))

:(mm,teach.setip,(
(loop, {
	(define, ipaddr, (get_ipaddress, <1> ))
	(==, (value, ipaddr),, {
		(receive, 2000)
	},{
		(ipaddress,(value,ipaddr))
		(break)
	})
}, (phone, timeout))
))

:(mm,teach.genlearn0,(
	<* User says Done *>
	:(ei,:(ag,:(ri,slang.p.num_ipaddresses),0,y,n):(e,:(wdial_frametype),SLIP,y,n),
		yy,(
		:(wdial_message,:(r,teach.IPMSS),OK,I)
		:(s,myip,:(wdial_prompt,
			:(r,teach.IPPRMPT),<* no default *>,
			:(pci,((,):(ri,slang.p.get_ipaddress,:(pn))),:(ri,slang.p.num_ipaddresses)),
			None
		))
		:(ei,:(ri,myip),None,,(
			:(pc,(
				:(ei,:(ri,slang.p.get_ipaddress,:(pn)),:(r,myip),(
					:(s,#,:(pn))
				))
			),:(ri,slang.p.num_ipaddresses))
			:(teach.write_scr)
			:(teach.write_scr,(:(r,teach.setip,:(r,#))))
			:(wdial_ipaddress,:(r,myip))
		))
	))

	:(wdial_status,(Writing script file))
	:(fc5)
	:(fg5,<1p>,(
		:(wdial_message,:(r,teach.MSGNOCF),OK,S)
		:(teach.exit)
	))
	:(fw5,:(r,teach.script))

	<* Always end the script cleanly when done *>
	:(fw5,:(bxo,0d0a0d0a))
	:(fw5,(<)(***  END Learned Script  ***)(>):(bxo,0d0a))
	:(fw5,(<)(*--------------------------*)(>):(bxo,0d0a))
	:(fw5,:(bxo,0d0a))
	:(fw5,(<)(***************************)(>):(bxo,0d0a))
	:(fw5,(<)(* Change Into Packet Mode *)(>):(bxo,0d0a))
	:(fw5,(<)(***************************)(>):(bxo,0d0a))
	:(fw5,:(tca,40)(topacket):(tca,41):(bxo,0d0a))
	:(fw5,:(bxo,0d0a))
	:(fw5,(<)(************************)(>):(bxo,0d0a))
	:(fw5,(<)(* Terminate The Script *)(>):(bxo,0d0a))
	:(fw5,(<)(************************)(>):(bxo,0d0a))
	:(fw5,:(tca,40)(status,{Connected}):(tca,41)
		:(bxo,0d0a))
	:(fw5,:(tca,40)(exit):(tca,41):(bxo,0d0a))

	:(fc5)
	:(wdial_status,(Script file written))

	:(d,teach.script)
	:(px)
))

:(mm,teach.genlearn1,(
	<* User says Abort, Do not write any scripts *>
	:(wdial_status,(Teach mode ABORTED...Hanging up))
	:(d,teach.script)
	:(teach.hangup)
	:(wdial_message,:(r,teach.ABMSS),OK,E)
	:(teach.exit)
))

:(o,,(
<**>
<* Return user's username, ask for it if necessary *>
<**>
))
:(mm,teach.username,(
	:(ei,:(wdial_username),,(
		:(wdial_username,:(wdial_prompt,(Please enter your username:)))
	))
	:(wdial_username)
))

:(o,,(
<**>
<* Return user's password, ask for it if necessary *>
<**>
))
:(mm,teach.passcode,(
	:(ei,:(wdial_passcode),,(
		:(wdial_passcode,:(wdial_prompt,(Please enter your password:),(*)))
	))
	:(wdial_passcode)
))

:(mm,teach.genlearn2,(
	<* Username *>

	<* Suck username from WDial *>

	:(teach.write_scr)
	:(teach.write_scr,(<2>(<)(* Send username *)(>)))
	:(teach.write_scr,(<2>:(tca,40)(send,):(tca,40)(uname):(tca,41)
		:(tca,40)(cr):(tca,41):(tca,41)))
	:(o2,:(teach.username):(bxo,0d))
))

:(mm,teach.genlearn3,(
	<* Password *>

	<* Suck password from WDial *>

	:(teach.write_scr)
	:(teach.write_scr,(<2>(<)(* Send password *)(>)))
	:(teach.write_scr,(<2>:(tca,40)(send,):(tca,40)(pword):(tca,41)
		:(tca,40)(cr):(tca,41):(tca,41)))
	:(o2,:(teach.passcode):(bxo,0d))
))

:(mm,teach.genlearn4,(
	<* Send a carriage return *>

	:(teach.write_scr)
	:(teach.write_scr,(<2>(<)(* Send a CR *)(>)))
	:(teach.write_scr,(<2>:(tca,40)(send,):(tca,40)(cr):(tca,41)
		:(tca,41)))
	:(o2,:(bxo,0d))
))
`
:(mm,teach.genlearn5,(
	<**>
	<* Send specific keys *>
	<**>

	:(d,<0>sendkeys)
	:(d,<0>exitflag)
	:(s,<0>numk,0)
	:(s,<0>kpos.)

	:(pcd,(
		<* Prepare to build the prompt *>
		:(s,<0>px,:(r,<0>sendkeys))

		<* Protect the innocent TRAC delimiters *>
		:(tra,<0>px,:(tca,40),:(tca,41)(:(tca,40)):(tca,40))
		:(tra,<0>px,:(tca,41),:(tca,41)(:(tca,41)):(tca,40))
		:(tra,<0>px,:(tca,60)(*),:(tca,41)(:(tca,60)):(tca,40)
			(*))
		:(tra,<0>px,(*):(tca,62),(*):(tca,41)(:(tca,62))
			:(tca,40))
		:(tra,<0>px,:(tca,44),:(tca,41)(:(tca,44)):(tca,40))
		:(s,<0>px,:(tca,40):(r,<0>px):(tca,41))

		<* Really build a prompt *>
		:(s,<0>prompt,:(teach.open)(wdial_prompt,)
			:(ei,:(r,<0>px),:(tca,40):(tca,41),,(
				:(tca,40)(Response so far: )("):(ri,<0>px)("):(tca,41)(...)
			))
			:(tca,40)(Send which key?):(tca,41)(,,)((I am done),)
			((Delete last key),(I am done),)
			((Abort without sending keys))
				:(pc,(
					(,):(tca,40):(r,teach.keys.k:(pn)):(tca,41)
				),:(r,teach.keys.num),1)
			:(tca,41))

		:(d,<0>px)			<* Throw away temp *>

		:(s,<0>pres,:(ri,<0>prompt))		<* Prompt the user *>

		:(pc,(
			:(ei,:(r,<0>pres),(Delete last key),(
				<* Delete Last key *>
				:(agi,:(r,<0>numk),0,(
					:(tps,<0>sendkeys,:(r,<0>kpos.
						:(r,<0>numk)))
					:(s,<0>sendkeys,:(tpb,<0>sendkeys))
					:(d,<0>kpos.:(r,<0>numk))
					:(s,<0>numk,:(as,:(r,<0>numk),1))
				))
				:(px)
			))
			:(ei,:(r,<0>pres),(I am done),(
				<* Finish up *>
				:(s,<0>exitflag)
				:(px)
			))
			:(ei,:(r,<0>pres),(Abort without sending keys),(
				<* Abort *>
				:(d,<0>sendkeys)
				:(s,<0>exitflag)
				:(px)
			))

			<* Store Last Position *>
			:(s,<0>numk,:(aa,0:(r,<0>numk),1))
			:(s,<0>kpos.:(r,<0>numk),:(tl,<0>sendkeys))

			<* Get String to send *>
			:(s,<0>keyv,:(r,<0>pres)) 			<* Default case *>
			:(pcd,(
				:(ei,:(r,<0>pres),:(r,teach.keys.k:(pn)),(
					:(s,<0>keyv,:(r,teach.keys.v:(pn)))
					:(px)
				))
			),:(r,teach.keys.num),1)

			:(0,:(r,<0>keyv))

			<* Add key to list *>
			:(s,<0>sendkeys,:(r,<0>sendkeys):(r,<0>keyv))
		))
		:(mhi,<0>exitflag,(:(px)))
	),-1)

	:(agi,:(tl,<0>sendkeys),0,(
		:(s,<0>temp,:(teach.convkeys,<0>sendkeys))			<* SLANG *>
	  :(pc,(
			:(s,<0>temp1,:(ts,<0>temp,,(`),(:(px))))
			:(tra,<0>temp1,`,,)
			:(tra,<0>temp1,( ),({ }))
			:(tra,<0>temp1,(:),:(tca,40)(char,58):(tca,41))
			:(tra,<0>temp1,(<)(*),({<}{*}))
			:(tra,<0>temp1,(*)(>),({*}),({>}))
		
			:(s,<0>temp2,:(r,<0>temp1))
			:(tra,<0>temp2,:(tca,40)(char),(:):(tca,40)(tca)) <* TRAC *>
			:(tra,<0>temp2,({),:(tca,40))
			:(tra,<0>temp2,(}),:(tca,41))
		
			:(teach.write_scr)
			:(teach.write_scr,(<2>(<)(* Send specific keys *)(>)))
			:(teach.write_scr,(<2>:(tca,40)(pause,1000):(tca,41)))
			:(teach.write_scr,(<2>:(tca,40)(send,):(r,<0>temp1)
				:(tca,41)))
		
			:(iwm,1000)
			:(o2,:(ri,<0>temp2))		<* Send to stream *>
		),-1)
		:(d,<0>temp,<0>temp1,<0>temp2) 	<* Clean up *>
	))

	:(d,<0>prompt,<0>keynum,<0>keyval,<0>pres,<0>keyv,<0>sendkeys,
		<0>exitflag,<0>numk,<0>kpos.)
))
:(mm,teach.genlearn6,(
	<* Ignore this prompt *>
))
:(mm,teach.genlearn7,(
	<* Wait for callback *>
	:(teach.callback)

	<* Write stuff to script file *>
	:(teach.write_scr,((<)(* Wait for Callback *)(>)))
	:(teach.write_scr,(:(tca,40)(callback):(tca,41)))
	:(teach.write_scr)
))

:(mm,teach.start_scr,(
	<* Script file header *>
	:(<0>w,((<)(*)
(*********************************************************************)(>)))
	:(<0>w,((<)(*)
( This script was automatically generated by WDial teach mode ver. )
	:(r,teach.Version)(.	*)(>)))
	:(<0>w,((<)(*)
( Created: ):(xcf)(                                  *)(>)))
	:(<0>w,((<)(*)
(*********************************************************************)(>)))
	:(<0>w)

	<* Read common TRAC code from GENLEARN.SCR *>
	:(fc5)
	:(fo5,(genlearn.scr),(
		:(wdial_message,:(r,teach.MSGNOGENLEARN),OK,S)
		:(teach.exit)
	))
	:(pcd,(
		:(s,<0>temp,:(fr5,,1000,(:(px))))

		:(teach.write_scr_nocrlf,(:(r,<0>temp)))
	),-1)
	:(fc5)

	:(teach.write_scr,(:(bxo,0d0a)))
	:(teach.write_scr,((<)(*** BEGIN Learned Script ***)(>)))
	:(teach.write_scr,((<)(*--------------------------*)(>):(bxo,0d0a)))

	:(teach.write_scr,((<)(***********************)(>)))
	:(teach.write_scr,((<)(* Check SLANG Version *)(>)))
	:(teach.write_scr,((<)(***********************)(>)))
	:(teach.write_scr,(:(tca,40)(checkver):(tca,41):(bxo,0d0a)))

	:(teach.write_scr,((<)(****************)(>)))
	:(teach.write_scr,((<)(* Connect/Dial *)(>)))
	:(teach.write_scr,((<)(****************)(>)))
	:(teach.write_scr,(:(tca,40)(connect):(tca,41):(bxo,0d0a)))


	:(teach.write_scr)
	:(d,<0>temp)
))

:(o,,(
<**>
<* Teach write script shortcut macros *>
<**>
))

:(mm,teach.open,((:):(tca,40)))
:(mm,teach.close,(:(tca,41)))
:(mm,teach.start_scrw,(
	:(teach.write_scr,(<1>))
))
:(mm,teach.write_scr,(
	:(s,teach.script,:(r,teach.script)<1>:(bxo,0d0a))
))
:(mm,teach.write_scr_nocrlf,(
	:(s,teach.script,:(r,teach.script)<1>)
))

:(o,,(
<**>
<* Le Bootstrap, called by WDial after reading in script file *>
<* <1> should contain the name of the script file to generate *>
<**>
))
:(mm,##,(
	<* Make sure filename has a .SCR extension if none specified	*>
	<* (This is temporary until WDial automatically appends .SCR) *>
	<*------------------------------------------------------------*>
	:(s,<0>filename,(<1p>))
	:(ttc,<0>filename,(.),,(
		:(s,<0>filename,:(r,<0>filename)(.scr))
	))
	<* Read in SLANG so we can reuse IP address parser *>
	:(mf,,slang.lng)
	
	<* Start learn mode *>
	:(teach.genlearn,:(r,<0>filename))

	<* Clean up, I should never get here but it looks good *>
	:(d,<0>filename)
))


:(o,,(
<**>
<* Check to make sure we're still connected *>
))
:(mm,teach.checkcarrier,(
	:(wdial_polli,physical,open,,,(
		:(wdial_status,(Not connected))
		:(wdial_message,:(r,teach.MSGHANGUP),OK,E)
		:(teach.exit)
	))
))

:(o,,(
<**>
<* Wait for a callback from a defender system *>
<**>
))
:(mm,teach.callback,(
	<* Case *>
	:(pc,(
		:(wdial_status,(Waiting for provider to hangup...):(bxo,0a)
			(Timeout in %d seconds),:(aq,:(wdial_phone,timeout)
			,1000))
		:(wdial_polli,physical,closed,:(wdial_phone,timeout),,(
			:(teach.hangup)
			:(wdial_status,(Not connected))
			:(wdial_message,:(r,teach.MSGNOHANGUP),OK,E)
			:(teach.exit)
		))

		<* Tell the customer what I am doing *>
		:(wdial_status,(Waiting for callback...):(bxo,0a)
			(Timeout in %d seconds),2400)
		:(s,<0>tmp,:(teach.iwt2,240000,RING))
		:(ttci,<0>tmp,RING,,(
			<* Wait for RING *>
			:(wdial_status,(Not connected))
			:(wdial_message,:(r,teach.MSGNOCALLBACK),OK,E)
			:(teach.exit)
		))

		:(wdial_status,(Answering phone))
		:(o2,ATA:(bxo,0d))			<* Tell modem to answer *>

		:(s,<0>tmp,:(teach.iwt2,:(wdial_phone,timeout),CONNECT))
		:(ttci,<0>tmp,CONNECT,,(
			<* Modem did not CONNECT *>
			:(wdial_status,(Not connected))
			:(wdial_message,:(r,teach.MSGNOCONNECT),OK,E)
			:(teach.exit)
		))

		<* Ready to send more stuff *>
		:(wdial_polli,physical,open,1000,(
			:(wdial_status,(Physical connection established))
		),(
			:(wdial_status,(Not connected))
			:(wdial_message,:(r,teach.MSGNOPHYSICAL),OK,E)
			:(teach.exit)
		))
		:(px)

	)) <* Case *>

	<* Clean up *>
	:(d,<0>tmp)
))

:(o,,(
<**>
<* Hang up modem   *>
<**>
))
:(mm,teach.hangup,(
	:(ibdf)
	:(wdial_polli,physical,close,2000,,(
		:(iz2)
		:(pcd,(
			:(o2,(+++))
			:(s,tmp,:(iwt2,2000,OK))
			:(ttci,tmp,OK,(
				:(px)
			))
		),3)
		:(pcd,(
			:(o2,ATH:(bxo,0d))
			:(s,tmp2,:(iwt2,2000,OK))
			:(ttci,tmp2,OK,(
				:(px)
			))
		),3)
	))
))

:(o,,(
<**>
<* Exit gracefully *>
<**>
))
:(mm,teach.exit,(
	:(wdial_status,(Not connected))
	:(g)
))


